/*
	Tank Clock Widget

	Created by Dean Beedell
	Clock face visuals adapted from KJC66's XWidget
	Re-coded by Dean Beedell
	Visuals added to and enhanced by Dean Beedell
	Sorted by Harry Whitfield

	email: dean.beedell@lightquick.co.uk
	http//lightquick.co.uk
*/

/*jslint multivar, this */

/*property
    MouseWheelPref, altKey, busy, clockFaceSwitchPref, clockSize, ctrlKey,
    data, duration, ease, endAngle, floor, getDate, getHours, getMilliseconds,
    getMinutes, getSeconds, getTime, getTimezoneOffset, hOffset,
    hRegistrationPoint, height, kEaseOut, length, mainDLSPref, match,
    maxLength, milliseconds, minLength, onMouseDown, onMouseUp, onMouseWheel,
    opacity, option, optionListPref1, optionListPref2, platform, readFile,
    rotation, round, scrollDelta, secyDLSPref, setTime, size, soundPref, split,
    src, srcHeight, srcWidth, start, startAngle, startTime, ticks, toFixed,
    toString, tooltip, vOffset, vRegistrationPoint, value, visible, width
*/

"use strict";

var mainWindow, background, background2, surround, switchFaces, dateText, secondText,
		hourHand, hourShadow, minuteHand, minuteShadow, secondHand, secondShadow,
		swMinuteHand, swHourHand, swSecondHand, bigReflection, windowReflection,
		startButton, stopButton, pin, prefs, tankHelp, helpbutton, tickSwitch,
		createLicence, setmenu, theDLSdelta, lprint, smallHourHand, smallMinuteHand,
		helpButton, showFace, mainScreen, settooltip, checkLockWidget;

var windowx = 775, windowy = 622;
var backxo = 0, backyo = 0, backgroundxo = 10, backgroundyo = 0;
var background2xo = 0, background2yo = 0;
var surroundxo = 0, surroundyo = 0;
var switchFacesxo = 660, switchFacesyo = 237;
var startButtonxo = 710, startButtonyo = 150;
var stopButtonxo = 710, stopButtonyo = 380;
var secondxo = 416, secondyo = 313, secondxr = 11.5, secondyr = 245.5;
var secondshadowxo = 416, secondshadowyo = 313, secondshadowxr = 22.5, secondshadowyr = 260.5;

var secondtextxo = 318, secondtextyo = 210;

var swSecondxo = 525, swSecondyo = 312, swSecondxr = 46.5, swSecondyr = 57;

var lampxo = 260, lampyo = 290;

var shadowOffset = 0;

var bigReflectionxo = 169, bigReflectionyo = 69;
var windowReflectionxo = 511, windowReflectionyo = 210;

var pinxo = 162, pinyo = 59;
var prefsxo = 162, prefsyo = 516;
var tankHelpxo = 1, tankHelpyo = 1;
var helpButtonxo = 625, helpButtonyo = 514;
var tickSwitchxo = 625, tickSwitchyo = 60;

var widgetName = "panzer WoT winrate.widget";

var counter = "Resources/sounds/counter.mp3";
var lock = "Resources/sounds/lock.mp3";
var till = "Resources/sounds/till01.mp3";
var ting = "Resources/sounds/ting.mp3";
var mistake = "Resources/sounds/mistake.wav";
var thhhh = "Resources/sounds/thhhh.mp3";
var winding = "Resources/sounds/winding.mp3";
var url = new URL();
var tempURL = "";

include("json2.js");
include("functions.js");
include("Resources/Licence/licence.js");

function startup() {
      sizeClock();
      mainScreen();
      createLicence(mainWindow);
      setmenu();
      settooltip();
      checkLockWidget();
      readURLdata();
      parseData();
      showface();
}

function  parseData() {
      var data = filesystem.readFile(url.outputFile);
      var obj = JSON.parse(data);
      var all = obj.data[userId].statistics.all;
      // calculate the win rate

      var winP = all.wins / all.battles;

      var rot1 =  (300 * winP) + 30;  // adjust the scale as the gauge is not 360 but starts at 30 and ends at 330


      //animationInterval = Number(preferences.animationPref.value),
      animationInterval = 20;
      animationDuration = animationInterval * Math.floor(1000 / animationInterval - 1);
      rotateAnimation(secondHand.rotation, rot1);

      //secondHand.rotation = rot1;
      //secondShadow.rotation = rot1;

      var eee = winP *100;
      secondText.data = eee.toFixed(2);

      print( "percent " + winP);

      if (winP < 0.50) {
          lamp.src = "Resources/images/red-lamptrue.png";
      }
      if (winP >= 0.50 && winP < 0.54 ) {
          lamp.src = "Resources/images/green-lamptrue.png";;
      }
      if (winP >= 0.54 && winP < 0.59 ) {
          lamp.src = "Resources/images/blue-lamptrue.png";;
      }
      if (winP >= 0.59) {
          lamp.src = "Resources/images/purple-lamptrue.png";;
      }

}




function readURLdata() {
      // read the data
      url.outputFile = system.widgetDataFolder + "tmp.json" ;

      if (preferences.wotUserId.value == "") {
           preferences.wotUserId.value = "1003670189";
        };
      userId = preferences.wotUserId.value;

      print ("userId "+ userId);
      // http://api.worldoftanks.com/wot/account/list/?application_id=demo&search=yereverluvinunclebert
      var tempURL = "http://api.worldoftanks.com/2.0/account/info/?application_id=16924c431c705523aae25b6f638c54dd&account_id="+userId;
      url.location = tempURL;

      url.fetch();

      /*print(all.hits_percents);
      print(all.piercings_received);	// should say 16297
      print(all.piercings);	// should say 16297
      print(all.damage_received);	// should say 16297
      print(all.damage_dealt);	// should say 16297
      */

      }


function sizeClock() {
	var scale = Number(preferences.clockSize.value) / 100;

	function sc(img, hOffset, vOffset, hReg, vReg) {
		img.hOffset = Math.round(hOffset * scale);
		img.vOffset = Math.round(vOffset * scale);
		img.width = Math.round(img.srcWidth * scale);
		img.height = Math.round(img.srcHeight * scale);
		if (hReg !== undefined) {
			img.hRegistrationPoint = Math.round(hReg * scale);
		}
		if (vReg !== undefined) {
			img.vRegistrationPoint = Math.round(vReg * scale);
		}
	}

	mainWindow.width = Math.round(windowx * scale);
	mainWindow.height = Math.round(windowy * scale);

	sc(background, backgroundxo, backgroundyo);
	sc(surround, surroundxo, surroundyo);
	sc(switchFaces, switchFacesxo, switchFacesyo);
	sc(startButton, startButtonxo, startButtonyo);
	sc(stopButton, stopButtonxo, stopButtonyo);

	sc(secondHand, secondxo, secondyo, secondxr, secondyr);
	sc(secondShadow, secondshadowxo + shadowOffset, secondshadowyo + shadowOffset, secondshadowxr, secondshadowyr);

	sc(lamp, lampxo, lampyo);

	sc(bigReflection, bigReflectionxo, bigReflectionyo);
	sc(windowReflection, windowReflectionxo, windowReflectionyo);
	sc(pin, pinxo, pinyo);
	sc(prefs, prefsxo, prefsyo);
	sc(tankHelp, tankHelpxo, tankHelpyo);
	sc(helpButton, helpButtonxo, helpButtonyo);
	sc(tickSwitch, tickSwitchxo, tickSwitchyo);

	secondText.size = Math.round(20 * scale);
	secondText.hOffset = Math.round(secondtextxo * scale);
	secondText.vOffset = Math.round(secondtextyo * scale);
	if (preferences.soundPref.value !== "disabled") {
		play(thhhh, false);
	}
}


startButton.onMouseDown = function (event) {

	if (preferences.soundPref.value !== "disabled") {
		play(ting, false);
	}
};

startButton.onMouseUp = function () {
	this.opacity = 255;
};

prefs.onMouseDown = function () {
	prefs.src = "Resources/images/prefs02.png";
};


prefs.onMouseUp = function () {
	prefs.src = "Resources/images/prefs01.png";
	if (preferences.soundPref.value !== "disabled") {
		play(winding, false);
	}
	showWidgetPreferences();
};

helpButton.onMouseDown = function () {
	helpButton.opacity = 255;
};

helpButton.onMouseUp = function () {
	helpButton.opacity = 1;
	tankHelp.visible = true;
	if (preferences.soundPref.value !== "disabled") {
		play(till, false);
	}
};

tankHelp.onMouseDown = function () {
	tankHelp.visible = false;
	if (preferences.soundPref.value !== "disabled") {
		play(ting, false);
	}
};

stopButton.onMouseDown = function () {
	log("stopBtton presssed");
		if (preferences.soundPref.value !== "disabled") {
			play(ting, false);
		}
	this.opacity = 10;
};

stopButton.onMouseUp = function () {
	this.opacity = 255;
};

hkey1.onKeyDown = function () {
   print("hello!");
   print('Hotkey ' + event.keyString + ' pressed')
        reloadWidget();
};

//the following function needs to operate on both the background and background2 faces, as the ctrl event can only be caught by the
//onMouseWheel itself on one object the event cannot be referred to by the key click on another object. The function would have to be duplicated
//for the background and background2 objects. Instead I have made the background object opacity to 1 so it seems as if it is not
//visible but it still responds to keyclicks and mousewheel movements even when supposedly 'invisible' - see the showFace function.

background.onMouseWheel = function (event) {
	var size = Number(preferences.clockSize.value),
		maxLength = Number(preferences.clockSize.maxLength),
		minLength = Number(preferences.clockSize.minLength),
		ticks = Number(preferences.clockSize.ticks),
		step = Math.round((maxLength - minLength) / (ticks - 1));

	//if (event.ctrlKey) {
		if (event.scrollDelta > 0) {
			if (preferences.MouseWheelPref.value === "up") {
				size -= step;
				if (size < minLength) {
					size = minLength;
				}
			} else {
				size += step;
				if (size > maxLength) {
					size = maxLength;
				}
			}
		} else if (event.scrollDelta < 0) {
			if (preferences.MouseWheelPref.value === "up") {
				size += step;
				if (size > maxLength) {
					size = maxLength;
				}
			} else {
				size -= step;
				if (size < minLength) {
					size = minLength;
				}
			}
		}
		preferences.clockSize.value = String(size);
		sizeClock();
	//}
};

	var updateMe = function () {	// called during rotateAnimation
			var now = animator.milliseconds, fraction, angle, value, valueT;
		
			if (now >= (this.startTime + this.duration)) {
				secondHand.rotation = this.endAngle;
				return false;
			}
			fraction = (now - this.startTime) / this.duration;
			angle = animator.ease(this.startAngle, this.endAngle, fraction, animator.kEaseOut);
			secondHand.rotation = angle;
			secondShadow.rotation = angle;

			return true;
		},

		rotateAnimation = function (startAngle, endAngle) {
			var rotate = new CustomAnimation(animationInterval, updateMe);
			rotate.duration = animationDuration;
			rotate.startAngle = startAngle;
			rotate.endAngle = endAngle;
			animator.start(rotate);
		};

